﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;


namespace TreeViewTraverse
{
    #region class

    public class commandclass : ICommand
        {
            public Action<object> action1;
            public Predicate<object> predicate1;

        #region Parameter constructor
        public commandclass(Predicate<object> predicate, Action<object> Action)
            {
                action1 = Action;
                predicate1 = predicate;
            }

        #endregion

        #region method
        public bool CanExecute(object Parameter)
            {
                if (predicate1 != null)
                {
                    return predicate1(Parameter);
                }
                else
                    return true;
            }

            public void Execute(object Parameter)
            {
                if (action1 != null)
                {
                    action1(Parameter);
                }

            }

        #endregion

        #region Event
        public event EventHandler CanExecuteChanged;
            public void raiseevent()
            {
                if (CanExecuteChanged != null)
                {
                    this.CanExecuteChanged(this, EventArgs.Empty);
                }
            }
        #endregion

    }
    #endregion
}

